COCKOS
CONFEDERATED FORUMS
Cockos : REAPER : NINJAM : Forums
Forum Home : Register : FAQ : Members List : Search :
Old 10-05-2017, 06:49 AM   #41
Mimo
Human being with feelings
 
Join Date: Apr 2015
Posts: 43
Default Silly question

Once the code fixes have been added, is it possible to compile from El Capitan without having to install High Sierra?
Mimo is offline   Reply With Quote
Old 10-05-2017, 07:10 AM   #42
Andi!
Human being with feelings
 
Andi!'s Avatar
 
Join Date: Nov 2015
Location: Germany
Posts: 76
Default

Debugging my problem in Reaper (when I add the FX) has revealed that it seems that the memory pointer that is coming to the Open/Construct methods of the IPlugAUFactory is not valid/big enough. It's the pointer mInstanceStorage, that will be set. For me the following new coding in MakePlug seems to be a problem when instantiating the object:

Code:
-    return new PLUG_CLASS_NAME(instanceInfo);
+    
+    if(memory)
+      return new(memory) PLUG_CLASS_NAME(instanceInfo);
+    else
+      return new PLUG_CLASS_NAME(instanceInfo);
Andi! is offline   Reply With Quote
Old 10-05-2017, 08:09 AM   #43
Andi!
Human being with feelings
 
Andi!'s Avatar
 
Join Date: Nov 2015
Location: Germany
Posts: 76
Default

Obviously the class name IPlugAU has to be replaced by PLUG_CLASS_NAME to heal the memory leak. Oli, could you please confirm and change that ?
I tried it on myself and AUval now successfully validates without -comp and with -comp, Logic validates it as well, Reaper doesn't crash anymore.

But I still have 2 problems:
- GarageBand doesn't find the plug-in
- The version of the plug-in is always 1.0.0 !?
Andi! is offline   Reply With Quote
Old 10-05-2017, 08:51 AM   #44
Andi!
Human being with feelings
 
Andi!'s Avatar
 
Join Date: Nov 2015
Location: Germany
Posts: 76
Default

Quote:
Originally Posted by Andi! View Post
But I still have 2 problems:
- GarageBand doesn't find the plug-in
- The version of the plug-in is always 1.0.0 !?
Both problems corrected ! I forgot to adjust the decimal version number in the plist file. It's hard to do this manually. Maybe it's really better to use the python script.
Andi! is offline   Reply With Quote
Old 10-05-2017, 11:29 AM   #45
olilarkin
Human being with feelings
 
olilarkin's Avatar
 
Join Date: Apr 2009
Location: Huddersfield, UK
Posts: 1,017
Default

Just so nobody rushes to push out updates, at this stage it seems like it's only garage band that has issues on High Sierra with Audio Units that use the component manager. So not quite as urgent a fix as what you might think from seeing this thread...
__________________
VirtualCZ | pMix | Endless Series | WDL-OL | Linkedin | Facebook
Available for Audio Dev tuition via Skype (IPlug/JUCE/C++)
olilarkin is online now   Reply With Quote
Old 10-05-2017, 11:49 AM   #46
Andi!
Human being with feelings
 
Andi!'s Avatar
 
Join Date: Nov 2015
Location: Germany
Posts: 76
Default

Who knows which apple update is breaking the component manager. Maybe good to know for some people that there are still memory allocation bugs in the current coding...
Andi! is offline   Reply With Quote
Old 10-05-2017, 04:26 PM   #47
Mimo
Human being with feelings
 
Join Date: Apr 2015
Posts: 43
Default

Hi, my plug (not commercial is to use in my music) uses audio besides, midi out, that's why I never compile it in Au, I'll have problems in High Sierra with it? or I should compile it again with all these changes in (WDL), thanks !!!.
Mimo is offline   Reply With Quote
Old 10-05-2017, 05:22 PM   #48
olilarkin
Human being with feelings
 
olilarkin's Avatar
 
Join Date: Apr 2009
Location: Huddersfield, UK
Posts: 1,017
Default

no not yet! IMO
__________________
VirtualCZ | pMix | Endless Series | WDL-OL | Linkedin | Facebook
Available for Audio Dev tuition via Skype (IPlug/JUCE/C++)
olilarkin is online now   Reply With Quote
Old 10-05-2017, 06:52 PM   #49
Mimo
Human being with feelings
 
Join Date: Apr 2015
Posts: 43
Default

Oh, how can I help?
Mimo is offline   Reply With Quote
Old 10-06-2017, 02:43 AM   #50
olilarkin
Human being with feelings
 
olilarkin's Avatar
 
Join Date: Apr 2009
Location: Huddersfield, UK
Posts: 1,017
Default

If I were you I'd wait till this gets merged into the master branch, then you know that we are happy with it
__________________
VirtualCZ | pMix | Endless Series | WDL-OL | Linkedin | Facebook
Available for Audio Dev tuition via Skype (IPlug/JUCE/C++)
olilarkin is online now   Reply With Quote
Old 10-06-2017, 03:14 AM   #51
Full Bucket
Human being with feelings
 
Full Bucket's Avatar
 
Join Date: Oct 2017
Posts: 4
Default

I think at this point it is time to thank you, Oli, for all your support, and all you other helpful folks, too!

Cheers, Björn
__________________
http://www.fullbucket.de/music
Full Bucket is offline   Reply With Quote
Old 10-06-2017, 03:30 AM   #52
olilarkin
Human being with feelings
 
olilarkin's Avatar
 
Join Date: Apr 2009
Location: Huddersfield, UK
Posts: 1,017
Default

no problem thanks for saying thanks. are your plug-ins made with iPlug?great plug-ins I never knew if so
__________________
VirtualCZ | pMix | Endless Series | WDL-OL | Linkedin | Facebook
Available for Audio Dev tuition via Skype (IPlug/JUCE/C++)
olilarkin is online now   Reply With Quote
Old 10-06-2017, 03:37 AM   #53
Full Bucket
Human being with feelings
 
Full Bucket's Avatar
 
Join Date: Oct 2017
Posts: 4
Default

Quote:
Originally Posted by olilarkin View Post
are your plug-ins made with iPlug?great plug-ins I never knew if so
Not yet, so far only 4 of them! But I am heavily porting everything. ;-)

Cheers, Björn
__________________
http://www.fullbucket.de/music
Full Bucket is offline   Reply With Quote
Old 10-06-2017, 10:18 AM   #54
olilarkin
Human being with feelings
 
olilarkin's Avatar
 
Join Date: Apr 2009
Location: Huddersfield, UK
Posts: 1,017
Default

Okay, after having tested on the latest high sierra, It seems that, using Endless Series 3.3 which does not have audiocomponent stuff yet...

- On 10.13 component manager entry point no longer works for 64-bit Audio Units. So neither reaper64 or Garageband can load the x64 version of Endless Series 3.3, where they can on 10.12

- auval -32 -comp -v aumf Oles oliL fails on 10.12 and 10.13, although Reaper will load it.

hope to have a snow leopard machine to test on soon, to see if my changes have broken backwards compatibility
__________________
VirtualCZ | pMix | Endless Series | WDL-OL | Linkedin | Facebook
Available for Audio Dev tuition via Skype (IPlug/JUCE/C++)
olilarkin is online now   Reply With Quote
Old 10-06-2017, 02:56 PM   #55
Mimo
Human being with feelings
 
Join Date: Apr 2015
Posts: 43
Default

Sorry for my noobiness, but only for testing purposes, it is not possible to use SL in VirtualBox?

Thanks for everything Oli,
Mimo is offline   Reply With Quote
Old 10-07-2017, 11:01 PM   #56
Andi!
Human being with feelings
 
Andi!'s Avatar
 
Join Date: Nov 2015
Location: Germany
Posts: 76
Default

Yes, it seems there is something broken.

Built plugs with new coding are throwing this on HS at class info validation (what is passing with old plug-ins and -comp!), coming from GetProperty kAudioUnitProperty_ClassInfo, GetState, AudioComponentInstanceGetComponent (instead of GetComponentInfo before), -3000 = invalid component id, maybe using the stuff from the core audio ComponentBase.h/cpp (or clarifying what has been changed) could fix it:

VERIFYING CLASS INFO
ERROR: -3000 IN CALL ClassInfo::GetProperty() call doesn't work when it is supposed to.


With old plug-ins (at least with aufx type) and without the new coding, the class validation passes but I'm getting this on HS (that could be fixed with a dependency to PLUG_DOES_MIDI in IPlugAU). BTW e.g. fabfilter (who are advertising with HS compatibility) is still throwing the very same validation error with -comp 32/64 bit.

Test MIDI
ERROR: MusicDeviceMIDIEvent should be invalid selector for AU type - noErr was returned

Last edited by Andi!; 10-08-2017 at 12:46 AM. Reason: AudioComponentInstanceGetComponent added
Andi! is offline   Reply With Quote
Old 10-08-2017, 02:42 AM   #57
Andi!
Human being with feelings
 
Andi!'s Avatar
 
Join Date: Nov 2015
Location: Germany
Posts: 76
Default

Quote:
Originally Posted by Andi! View Post
... coming from GetProperty kAudioUnitProperty_ClassInfo, GetState, AudioComponentInstanceGetComponent (instead of GetComponentInfo before), -3000 = invalid component id ...
Finally I added the (deprecated, other possibility would be the mentioned ComponentBase coding) GetComponentInfo from the old coding just for the case AudioComponentInstanceGetComponent isn't returning successfully and the -3000 error is gone now on HS for 32 and 64 bit. :-) Should be easy to fix the MIDI thing.
Andi! is offline   Reply With Quote
Old 10-08-2017, 05:02 AM   #58
Andi!
Human being with feelings
 
Andi!'s Avatar
 
Join Date: Nov 2015
Location: Germany
Posts: 76
Default

With my changes above aufx plugins already validate successfully for all combinations (32/64 comp/nocomp) on HS (most notably with plug-ins built with older OS X versions - El Capitan in my case). ;-) Apple aumf plugins themselves also throw the same MIDI validation error on HS.
Andi! is offline   Reply With Quote
Old 10-08-2017, 12:08 PM   #59
olilarkin
Human being with feelings
 
olilarkin's Avatar
 
Join Date: Apr 2009
Location: Huddersfield, UK
Posts: 1,017
Default

can you put your changes on github? not sure i quite understand what you are saying, but if you have fixed something thanks!
__________________
VirtualCZ | pMix | Endless Series | WDL-OL | Linkedin | Facebook
Available for Audio Dev tuition via Skype (IPlug/JUCE/C++)
olilarkin is online now   Reply With Quote
Old 10-12-2017, 07:46 AM   #60
Andi!
Human being with feelings
 
Andi!'s Avatar
 
Join Date: Nov 2015
Location: Germany
Posts: 76
Default

Quote:
Originally Posted by olilarkin View Post
can you put your changes on github? not sure i quite understand what you are saying, but if you have fixed something thanks!
I'm not using any of the branches here and have made many other changes in IPlugAU but I pm you the few changes I made concerning this so you can easily review/use them.
Andi! is offline   Reply With Quote
Old 10-13-2017, 08:08 AM   #61
Mimo
Human being with feelings
 
Join Date: Apr 2015
Posts: 43
Default

Due to the lack of midi output in Au, I am forced to use Vst.
Can anyone tell me, if I will have problems compiling normally VST in WDL IPlug (XCode + El Capitan) and later using it in HighSierra?
In my RIG I use El Capitan but in my group two have already updated to High Sierra.
I would not want compatibility problems and there is no time to ask them to test.
Thanks in advance.
My humble plug, besides modifying the audio according to certain parameters, share preset changes, and sends messages midi (rt) for synchronization etc.

Thanks


sorry for the panic
Mimo is offline   Reply With Quote
Old 10-14-2017, 02:25 AM   #62
olilarkin
Human being with feelings
 
olilarkin's Avatar
 
Join Date: Apr 2009
Location: Huddersfield, UK
Posts: 1,017
Default

you shouldn't have any problems using VST compiled on sierra on high sierra. For info, both myself and youlean have done some work on audiounit midi out, I will be rolling it into the master branch of wdlol soon

here is an old branch which may work! can't remember

https://github.com/olilarkin/wdl-ol/tree/aumidiout
__________________
VirtualCZ | pMix | Endless Series | WDL-OL | Linkedin | Facebook
Available for Audio Dev tuition via Skype (IPlug/JUCE/C++)
olilarkin is online now   Reply With Quote
Old 10-14-2017, 04:00 AM   #63
Youlean
Human being with feelings
 
Youlean's Avatar
 
Join Date: May 2015
Location: Serbia
Posts: 542
Default

Quote:
Originally Posted by olilarkin View Post
you shouldn't have any problems using VST compiled on sierra on high sierra. For info, both myself and youlean have done some work on audiounit midi out, I will be rolling it into the master branch of wdlol soon

here is an old branch which may work! can't remember

https://github.com/olilarkin/wdl-ol/tree/aumidiout
I can confirm that my MIDI out works great in one customers plugin, though there might be better way to include this in framework...
__________________
Website | Facebook Page | IPlug-Youlean
Youlean is offline   Reply With Quote
Old 10-14-2017, 07:57 AM   #64
Mimo
Human being with feelings
 
Join Date: Apr 2015
Posts: 43
Default

Sometimes in the struggle to learn and carry out an idea, one looks for it needs and forgets to thank.

I take this opportunity to thank you all for your generosity, knowledge and efforts to Oli, Tale, Youlean and all those who improve this framework
and get us out of trouble to those who try to learn something..
Mimo is offline   Reply With Quote
Old 10-15-2017, 01:00 AM   #65
br_ck1
Human being with feelings
 
Join Date: Dec 2015
Posts: 39
Default

Hi,

after my thank you to all people trying to improve WDL(-OL), may I ask if (since this discussion is becoming longer and longer - and more difficult to follow) could you please provide in one single place (for example in the first post on this thread, by OLI) a full list of all changes/steps to be "manually" made to fix this incompatibility with macOS ? It would be very appreciated, thanks!
br_ck1 is offline   Reply With Quote
Old 10-15-2017, 01:05 AM   #66
olilarkin
Human being with feelings
 
olilarkin's Avatar
 
Join Date: Apr 2009
Location: Huddersfield, UK
Posts: 1,017
Default

Personally I would wait until the changes get merged to the master branch. I'm still trying to figure out if it's possible to retain snow leopard compatibility
__________________
VirtualCZ | pMix | Endless Series | WDL-OL | Linkedin | Facebook
Available for Audio Dev tuition via Skype (IPlug/JUCE/C++)
olilarkin is online now   Reply With Quote
Old 10-15-2017, 01:17 AM   #67
br_ck1
Human being with feelings
 
Join Date: Dec 2015
Posts: 39
Default

Quote:
Originally Posted by olilarkin View Post
Personally I would wait until the changes get merged to the master branch. I'm still trying to figure out if it's possible to retain snow leopard compatibility
Hi Oli,

sure, I mean 'once the update/fix will be 100% completed' of course. Again, thank you so much for your support !

If then you could write just a few lines (once and in a single "place") on how to 'manually update', it would be amazing... I'm scared that I could miss something in the fixing process, and I bet other developers share the same fear
br_ck1 is offline   Reply With Quote
Old 10-27-2017, 09:26 AM   #68
carlcaulkett
Human being with feelings
 
carlcaulkett's Avatar
 
Join Date: Oct 2017
Location: London, England
Posts: 5
Default General problems with AU Plug-ins on High Sierra

Hello, I found this forum after dealing with a splendid chap called Bjorn (goes by the name https://forum.cockos.com/member.php?u=120354 here) in order to get his excellent FB-3300 plugin to work with Logic Pro X under High Sierra.

I managed to get that plug-in working but I am having severe difficulties in getting other 3rd party plug-ins to be scanned and recognised by Logic.

I know that I can force an AU rescan by deleting `com.apple.audiounits.cache` in my `~/Library/Caches/AudioUnitCache` folder, and also it seems that rebooting before adding a new plug-in helps as well. Both of these "solutions" are having a sub-optimal impact on my workflow. Do any of you bright sparks know any solutions to this puzzle, or is it just a case of waiting for new releases of software to come out.

On that subject, is the onus on: Apple to make changes to macOS, Logic (Apple) to make changes to Logic Pro, the plug-in authors to make changes to the plug-ins.

I hope you don't mind me asking this generalised question in this specialist forum, but I figured the brain-cell quotient would be higher here!
carlcaulkett is offline   Reply With Quote
Old 10-27-2017, 10:08 AM   #69
Andi!
Human being with feelings
 
Andi!'s Avatar
 
Join Date: Nov 2015
Location: Germany
Posts: 76
Default

You could try to write a small terminal script that deletes the cache automatically (with admin rights).
Andi! is offline   Reply With Quote
Old 10-28-2017, 04:40 AM   #70
carlcaulkett
Human being with feelings
 
carlcaulkett's Avatar
 
Join Date: Oct 2017
Location: London, England
Posts: 5
Default

The problem is that even with a rescan, most of the time any new AU components are not recognised. This is a software problem, not an operational problem. The thrust of my question was: who is responsible and with whom do I attempt to engage and encourage to find a solution?
carlcaulkett is offline   Reply With Quote
Old 10-28-2017, 05:27 AM   #71
gstuff
Human being with feelings
 
Join Date: Feb 2014
Posts: 53
Default

As mentioned earlier in this thread, a restart seems to be required in HS, not just clearing the caches or a rescan. For solution: https://developer.apple.com/bug-reporting.
gstuff is offline   Reply With Quote
Old 11-01-2017, 07:36 PM   #72
carlcaulkett
Human being with feelings
 
carlcaulkett's Avatar
 
Join Date: Oct 2017
Location: London, England
Posts: 5
Default General problems with AU Plug-ins on High Sierra [SOLVED, I think...]

Quote:
Originally Posted by carlcaulkett View Post
On that subject, is the onus on: Apple to make changes to macOS, Logic (Apple) to make changes to Logic Pro, the plug-in authors to make changes to the plug-ins.
I bring good news! I've just installed the newly-released macOS 10.13.1 High Sierra update from the App Store, and then downloaded and installed an AU Plugin from KVRAudio. I was then able to run Logic Pro X and use the plugin without any cache deletion or rebooting malarky. It just worked. I'll have to try a couple of other plugins to be really confident, but I'm hoping that my problems have been sorted.

Maybe this 10.13.1 update will sort some of the WDL specific problems that others are having here. One way to find out...

Last edited by carlcaulkett; 11-01-2017 at 07:37 PM. Reason: Typo
carlcaulkett is offline   Reply With Quote
Old 11-01-2017, 11:21 PM   #73
Andi!
Human being with feelings
 
Andi!'s Avatar
 
Join Date: Nov 2015
Location: Germany
Posts: 76
Default

These are great news. If you (or somebody else) find the time (I'm not at home for days), it would be great if you could test 2 things:
- do audio effects with midi = "aufm" plug-ins (e.g. Fabfilter Q2) validate in terminal/auval and -comp flag?
- does GarageBand recognize (all/IPlug) 3rd party plug-ins?

Thank you!
Andi! is offline   Reply With Quote
Old 11-02-2017, 03:40 AM   #74
carlcaulkett
Human being with feelings
 
carlcaulkett's Avatar
 
Join Date: Oct 2017
Location: London, England
Posts: 5
Default

Quote:
Originally Posted by Andi! View Post
These are great news. If you (or somebody else) find the time (I'm not at home for days), it would be great if you could test 2 things:
- do audio effects with midi = "aufm" plug-ins (e.g. Fabfilter Q2) validate in terminal/auval and -comp flag?
- does GarageBand recognize (all/IPlug) 3rd party plug-ins?

Thank you!
Hi Andi! I'd be happy to test those things. Only thing is, can you give me some exact directions on what I should do to do this?

One other thing. The ! in your name... is that a tribute to Neu! one of my most favourite bands ever??!!
carlcaulkett is offline   Reply With Quote
Old 11-02-2017, 04:04 AM   #75
Andi!
Human being with feelings
 
Andi!'s Avatar
 
Join Date: Nov 2015
Location: Germany
Posts: 76
Default

For GarageBand it's easy: just install it from the store and test some with IPlug made demo plug-ins (e.g. from Hornet, LVC Audio or TB Pro Audio).
For the auval install the demo of Fabfilter Pro Q2, open the terminal app, type auval -a to list the installed plugins, find fabfilter and type auval -v -comp and the 3 ids of the plug-in in the list of auval.

No, I have just choosen the user name because somebody else has the one without "!" . :-)
Andi! is offline   Reply With Quote
Old 11-02-2017, 01:43 PM   #76
carlcaulkett
Human being with feelings
 
carlcaulkett's Avatar
 
Join Date: Oct 2017
Location: London, England
Posts: 5
Default

Quote:
Originally Posted by Andi! View Post
For GarageBand it's easy: just install it from the store and test some with IPlug made demo plug-ins (e.g. from Hornet, LVC Audio or TB Pro Audio).
For the auval install the demo of Fabfilter Pro Q2, open the terminal app, type auval -a to list the installed plugins, find fabfilter and type auval -v -comp and the 3 ids of the plug-in in the list of auval.

No, I have just choosen the user name because somebody else has the one without "!" . :-)
I may have been over optimistic with my "good" news yesterday. I've just downloaded some stuff from "Computer Music" Issue 250, and some of that is still refusing to install without rebooting and all that stuff.
carlcaulkett is offline   Reply With Quote
Old 11-10-2017, 11:57 AM   #77
Caiminatrix
Human being with feelings
 
Join Date: Oct 2016
Posts: 20
Default

I'm using High Sierra and I've noticed some AU plug-ins prompt the user in Garage Band to lower security settings and then seem to work fine.

I built a plug-in targeting the 10.5 sdk and tried to using it in Garage Band. At first I did not get the "lower securities prompt" and it didn't load. Then I loaded an AU that did trigger the prompt and lowered securities. After lowering the securities using the other plug-in, my AU loaded fine.

So as a temporary workaround, does anyone know what I should include in my AU plug-in that would trigger this prompt? I'm sure my users would rather lower settings upon loading my plug-in rather than hunting for another AU that will.
Attached Images
File Type: png GBAU.png (16.9 KB, 21 views)
Caiminatrix is offline   Reply With Quote
Old 11-11-2017, 12:37 PM   #78
lorcan
Human being with feelings
 
lorcan's Avatar
 
Join Date: Sep 2009
Posts: 6
Default

I'm getting the same error with aumf under HS, although I'm not using IPlug.

ERROR: MusicDeviceMIDIEvent should be invalid selector for AU type - noErr was returned

I've filed a bug with Apple and they acknowledged it, other people have reported it too. Unfortunately they can't say when / if it will be fixed ...

The strange thing is that Logic and GarageBand seem to work fine in spite of that, even though Logic uses auval to validate the AU's.
__________________
lmdsp audio plug-ins

Last edited by lorcan; 11-11-2017 at 12:38 PM. Reason: Added LPX / GB details
lorcan is offline   Reply With Quote
Old 11-14-2017, 09:26 AM   #79
Andi!
Human being with feelings
 
Andi!'s Avatar
 
Join Date: Nov 2015
Location: Germany
Posts: 76
Default

Quote:
Originally Posted by lorcan View Post
I'm getting the same error with aumf under HS, although I'm not using IPlug.
I had sent a bug report to apple a few weeks ago and got not response so far. Great, that you got an answer. Obviously it's a bug when plug-ins of big companies have the same problem and advertise with HS compatibility. :-)
Andi! is offline   Reply With Quote
Reply

Thread Tools
Display Modes

Posting Rules
You may not post new threads
You may not post replies
You may not post attachments
You may not edit your posts

BB code is On
Smilies are On
[IMG] code is On
HTML code is Off

Forum Jump


All times are GMT -7. The time now is 06:12 AM.


Powered by vBulletin® Version 3.8.11
Copyright ©2000 - 2017, vBulletin Solutions Inc.